Package org.apache.tapestry5.runtime

## Interface PageLifecycleCallbackHub

- All Known Subinterfaces:
    `Page`
  All Known Implementing Classes:
    `PageImpl`

      public interface PageLifecycleCallbackHub

  Defines a way for different aspects of a page to add callbacks for important lifecycle events.
  Since:
    5.3.4
  See Also:
    `ComponentResources.getPageLifecycleCallbackHub()`

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `addPageAttachedCallback​(Runnable callback)` | Adds a callback for when the page is attached to the request.
    `void` | `addPageDetachedCallback​(Runnable callback)` | Adds a callback for when the page is detached from the request.
    `void` | `addPageLoadedCallback​(Runnable callback)` | Adds a callback for when the page is first loaded.
    `void` | `addResetCallback​(Runnable callback)` | A reset occurs when a request for a page arrives that did not originate on the same page.
    `void` | `addVerifyCallback​(Runnable callback)` | Adds a verify callback, which is allowed while the page is loading.

- - ### Method Detail

    - #### addPageLoadedCallback

          void addPageLoadedCallback​(Runnable callback)

      Adds a callback for when the page is first loaded. Callbacks are invoked in the order they are added to the page. They are invoked once and then discarded.
      Parameters:
        `callback` - invoked once, when page is first loaded
      Since:
        5.3.4

    - #### addPageAttachedCallback

          void addPageAttachedCallback​(Runnable callback)

      Adds a callback for when the page is attached to the request.
      Parameters:
        `callback` -
      Since:
        5.3.4

    - #### addPageDetachedCallback

          void addPageDetachedCallback​(Runnable callback)

      Adds a callback for when the page is detached from the request.
      Parameters:
        `callback` -
      Since:
        5.3.4

    - #### addVerifyCallback

          void addVerifyCallback​(Runnable callback)

      Adds a verify callback, which is allowed while the page is loading. Such callbacks are invoked once, after the page has been loaded successfully, and are then discarded. This was added specifically to ensure that components only verify that required parameters are bound after all components and mixins of the page have had a chance to initialize.
      Parameters:
        `callback` - to be invoked after page loaded
      Since:
        5.3

    - #### addResetCallback

          void addResetCallback​(Runnable callback)

      A reset occurs when a request for a page arrives that did not originate on the same page. This gives the application a chance to reset the state of the page.
      Parameters:
        `callback` - invoked when a page is activated by link from some other page.